<?php header("Content-type: text/html; charset=utf8"); ?>
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=utf8">
   <meta name="Author" content="Vadim Zeitlin">
   <title>List of translators for wxWidgets</title>
</head>
<body>

<?php
// ---------------------------------------------------------------------
//           Configuration of translations status script
// ---------------------------------------------------------------------

// Setup ViewCVS web access here, must point to the directory with .po files:
$cvs_url="http://cvs.wxwindows.org/viewcvs.cgi/*checkout*/wxWidgets/locale/";

// CVS branch used to generate the page:
$cvs_branch="HEAD";

// Name of POT file (in cvs_url directory):
$potfile="wxstd.po";

// Path to images (1x16 bars):
$img_translated="images/translated.png";
$img_fuzzy="images/fuzzy.png";
$img_untranslated="images/untranslated.png";

// Width of status bar:
$graph_width = 200;


// ---------------------------------------------------------------------
//                     List of our translators
// ---------------------------------------------------------------------

$translators = array(
   'af' => '<a href="mailto:rkwjpj@@puk.ac.za">Petri Jooste</A>',
   'sq' => '<a href="mailto:besnik@@programeshqip.org>Besnik Bleta</A>',
   'eu' => '<A HREF="mailto:3arrano@@euskalerria.org">3ARRANO Euskalgintza Taldea</A>',
   'ca' => '<a href="mailto:paubcrespo@@hotmail.com">Pau Bosch i Crespo</A>',
   'zh_CN' => '<a href="mailto:mrfx@@fm365.com">mrfx</a>,<br/>
               <a href="mailto:liouxiao@@hotmail.com"Liu XiaoXi</a>',
   'zh_TW' => '<a href="mailto:pal.tw@@yahoo.com.tw">pal.tw</A>',
   'cs' => '<a href="mailto:vaclav.slavik@@matfyz.cz">Vaclav Slavik</A><br/>
           <a href="mailto:deirdre_skye@@web.de">Herbert Breunung</a>',
   'da' => '<a href="mailto:leif@@danmos.dk">Leif Jensen</A>,<br>
            <a href="mailto:Henrik@@fangorn.dk">Henrik Rder Clausen</A>
            <a href="mailto:mulrich15@@yahoo.dk">Morten Rbjerg Ulrich</a>',
   'nl' => '<a href="mailto:phubers@@solve-i-t.com">Patrick Hubers</A>',
   'fi' => '<a href="mailto:kgb@@compart.fi">Kaj G Backas</a><br/>
            <a href="mailto:lanurmi@@iki.fi">Lauri Nurmi</a><br/>
            <a href="mailto:jmsalli79@@hotmail.com">Jaakko Salli</a>',
   'fr' => '<a href="mailto:Stephane.Junique@@optics.kth.se">Stephane Junique</A>,<br>
            <a href="mailto:lionel.allorge@@lunerouge.com">Lionel Allorge</A>,<br>
            <a href="mailto:Gilles.Guyot@@Krypton.be">Gilles Guyot</A>',
   'de' => '<a href="mailto:DanR@@gmx.de">Daniel Reith</A>,<br/>
            <a href="mailto:sparhawk@@aon.at">Gerhard Gruber</A>,<br/>
            <a href="mailto:stefan@@hedemann.de">Stefan Hedemann</A>,<br/>
            <a href="mailto:D.Reymann@@geisenheim.mnd.fh-wiesbaden.de">Dr. Detlev Reymann</A>,<br/>
            Mark Johnson,<br/>
            <a href="mailto:martinnost@@users.sf.net">Martin Jost</a>,<br/>
            <a href="mailto:deirdre_skye@@web.de">Herbert Breunung</a>,<br/>
	    <a href="mailto:chbuck@gmail.com">Ch. Buck</a>',
   'el' => '<a href="mailto:tsolako1@@otenet.gr">Tsolakos Stavros</A>,<br/>
            <a href="mailto:nassosy@@innerprocess.com">Nassos Yiannopoulos</A>',
   'gl_ES' => '<a href="mailto:leandro.regueiro@@gmail.com">Leandro Regueiro</a><br/>
	           <a href="mailto:correoadrian82@@hotmail.com">Adrin Gonzlez Alba</a>',
   'hi' => '<a href="mailto:dysxhi@@yahoo.co.in">Dhananjaya Sharma</A>',
   'hu' => '<a href="mailto:Janos_Vegh@@users.sourceforge.net">Vgh Jnos Dr.</A>',
   'id' => '<a href="mailto:bambang@@3wsi.com">Bambang Purnomosidi D. P.</a>',
   'it' => '<a href="mailto:mbarbon@@cpan.org">Mattia Barbon</A>,<br/>
            <a href="mailto:m.cavallini@@koansoftware.com">Marco Cavallini</A>
        (<a href="http://www.koansoftware.com" target=_new>Koan Software</a>)',
   'ja' => '<a href="mailto:james.bishop1@@tiscali.co.uk">James Bishop</a>,<br/>
        <a href="mailto:saito@@inetrt.skcapi.co.jp">Hiroshi Saito</a>,
        <a href="mailto:suzumizaki@@free.japandesign.ne.jp">Suzumizaki-Kimitaka</a>',
   'nb' => '<a href="mailto:hans@@nordhaug.priv.no">Hans F. Nordhaug</a>',
   'pl' => '<a href="mailto:matis@@linuxmail.org">Piotr Ma&#263;kowiak</A>,<br/>
            <a href="mailto:jpiw@@go2.pl">Janusz Piwowarski</a>,<br/>
            <a href="mailto:abx@@abx.art.pl">ABX</a>',
   'pt_BR' => '<a href="mailto:e.a.tacao@@terra.com.br">E.A. Tacao</a>,<br>,
               <a href="mailto:jecdiniz@@yahoo.com.br">Jos Eduardo de Carvalho Diniz</a>',
   'ru' => '<a href="mailto:wolfsoft@@mail.ru">Dennis Prochko</a>,<br>,
            <a href="mailto:rolinsky@@mema.ucl.ac.be">Roman Rolinsky</a>,<br/>
            <a href="mailto:vadim@@wxwindows.org">Vadim Zeitlin</a>,<br/>
            <a href="mailto:kai@@cmail.ru">Andrew V. Samoilov</a>',
   'es' => '<a href="mailto:guille@@iies.es">Guillermo Rodriguez Garcia</A>,<br/>
            <a href="mailto:jsj666@@hotmail.com">JSJ</a>,<br/>
            <a href="mailto:francisco.vila@@hispalinux.es">Francisco Vila</a>,<br/>
	        <a href="mailto:correoadrian82@@hotmail.com">Adrin Gonzlez Alba</a>',
   'sl' => '<a href="mailto:roman.plevel@@iskratr.si">Roman Plevel</A>,<br/>
            <a href="mailto:miles@@filmsi.net">Martin Srebotnjak</A>',
   'sv' => '<a href="mailto:jonas@@arbor.se">Jonas Rydberg</A>,<br/>
            <a href="mailto:kgb@@compart.fi">Kaj G Backas</A>',
   'tr' => '<a href="mailto:dogusanh@@dynaset.org">Hakki Dogusan</A>',
   'uk' => '<a href="mailto:manko@@salingshot.co.nz">Eugene Manko</A>,<br/>
            <a href="mailto:k_ilya@@ukr.net>Ylia K</a>',
);


// ---------------------------------------------------------------------
//                   List of recognized languages
// ---------------------------------------------------------------------

$langnames = array(
    "aa" => "Afar",
    "ab" => "Abkhazian",
    "ae" => "Avestan",
    "af" => "Afrikaans",
    "am" => "Amharic",
    "ar" => "Arabic",
    "as" => "Assamese",
    "ay" => "Aymara",
    "az" => "Azerbaijani",
    "ba" => "Bashkir",
    "be" => "Byelorussian",
    "bg" => "Bulgarian",
    "bh" => "Bihari",
    "bi" => "Bislama",
    "bn" => "Bengali",
    "bo" => "Tibetan",
    "br" => "Breton",
    "bs" => "Bosnian",
    "ca" => "Catalan",
    "ce" => "Chechen",
    "ch" => "Chamorro",
    "co" => "Corsican",
    "cs" => "Czech",
    "cu" => "Church Slavic",
    "cv" => "Chuvash",
    "cy" => "Welsh",
    "da" => "Danish",
    "de" => "German",
    "dz" => "Dzongkha",
    "el" => "Greek",
    "en" => "English",
    "eo" => "Esperanto",
    "es" => "Spanish",
    "et" => "Estonian",
    "eu" => "Basque",
    "fa" => "Persian",
    "fi" => "Finnish",
    "fj" => "Fijian",
    "fo" => "Faroese",
    "fr" => "French",
    "fy" => "Frisian",
    "ga" => "Irish",
    "gd" => "Gaelic",
    "gl" => "Galician",
    "gn" => "Guarani",
    "gu" => "Gujarati",
    "ha" => "Hausa",
    "he" => "Hebrew",
    "hi" => "Hindi",
    "ho" => "Hiri Motu",
    "hr" => "Croatian",
    "hu" => "Hungarian",
    "hy" => "Armenian",
    "hz" => "Herero",
    "ia" => "Interlingua",
    "id" => "Indonesian",
    "ie" => "Interlingue",
    "ik" => "Inupiaq",
    "is" => "Icelandic",
    "it" => "Italian",
    "iu" => "Inuktitut",
    "ja" => "Japanese",
    "jw" => "Javanese",
    "ka" => "Georgian",
    "ki" => "Kikuyu",
    "kj" => "Kuanyama",
    "kk" => "Kazakh",
    "kl" => "Kalaallisut",
    "km" => "Khmer",
    "kn" => "Kannada",
    "ko" => "Korean",
    "ks" => "Kashmiri",
    "ku" => "Kurdish",
    "kv" => "Komi",
    "kw" => "Cornish",
    "ky" => "Kirghiz",
    "la" => "Latin",
    "lb" => "Letzeburgesch",
    "ln" => "Lingala",
    "lo" => "Lao",
    "lt" => "Lithuanian",
    "lv" => "Latvian",
    "mg" => "Malagasy",
    "mh" => "Marshall",
    "mi" => "Maori",
    "mk" => "Macedonian",
    "ml" => "Malayalam",
    "mn" => "Mongolian",
    "mo" => "Moldavian",
    "mr" => "Marathi",
    "ms" => "Malay",
    "mt" => "Maltese",
    "my" => "Burmese",
    "na" => "Nauru",
    "ne" => "Nepali",
    "ng" => "Ndonga",
    "nl" => "Dutch",
    "nn" => "Norwegian Nynorsk",
    "nb" => "Norwegian Bokmal",
    "nr" => "Ndebele, South",
    "nv" => "Navajo",
    "ny" => "Chichewa; Nyanja",
    "oc" => "Occitan",
    "om" => "(Afan) Oromo",
    "or" => "Oriya",
    "os" => "Ossetian; Ossetic",
    "pa" => "Panjabi",
    "pi" => "Pali",
    "pl" => "Polish",
    "ps" => "Pashto, Pushto",
    "pt" => "Portuguese",
    "qu" => "Quechua",
    "rm" => "Rhaeto-Romance",
    "rn" => "Rundi",
    "ro" => "Romanian",
    "ru" => "Russian",
    "rw" => "Kinyarwanda",
    "sc" => "Sardinian",
    "sd" => "Sindhi",
    "se" => "Northern Sami",
    "sg" => "Sangro",
    "sh" => "Serbo-Croatian",
    "si" => "Sinhalese",
    "sk" => "Slovak",
    "sl" => "Slovenian",
    "sm" => "Samoan",
    "sn" => "Shona",
    "so" => "Somali",
    "sq" => "Albanian",
    "sr" => "Serbian",
    "ss" => "Siswati",
    "st" => "Sesotho",
    "su" => "Sundanese",
    "sv" => "Swedish",
    "sw" => "Swahili",
    "ta" => "Tamil",
    "te" => "Telugu",
    "tg" => "Tajik",
    "th" => "Thai",
    "ti" => "Tigrinya",
    "tk" => "Turkmen",
    "tl" => "Tagalog",
    "tn" => "Setswana",
    "to" => "Tonga",
    "tr" => "Turkish",
    "ts" => "Tsonga",
    "tt" => "Tatar",
    "tw" => "Twi",
    "ty" => "Tahitian",
    "ug" => "Uighur",
    "uk" => "Ukrainian",
    "ur" => "Urdu",
    "uz" => "Uzbek",
    "vi" => "Vietnamese",
    "vo" => "Volapuk",
    "wo" => "Wolof",
    "xh" => "Xhosa",
    "yi" => "Yiddish",
    "yo" => "Yoruba",
    "za" => "Zhuang",
    "zh" => "Chinese",
    "zu" => "Zulu",
);

?>

<?php
// If the URL is www.wxwindows.org/i18n.php, display summary of all
// translations, if it is www.wxwindows.org/i18n.php?info=xy, display
// information about translators of language xy:
$language=$_GET['info'];
if ($language == '') {
// ----------------------------------------------------------------------
//                    Display translations summary:
// ----------------------------------------------------------------------
?>

<table width=100% border=0 cellpadding=3 cellspacing=0>
<tr>
<td bgcolor="#004080" align=left height=24 background="images/bluetitlegradient.gif">
<font size=+1 face="Arial, Lucida Sans, Helvetica" color="#FFFFFF">
<b>wxWidgets internationalization</b>
</font>
</td>
</tr>
</table>

<p>

<center>
    <a href="#available">Available translations</a> |
    <a href="#howtohelp">How to help</a>
</center>

<p>
wxWidgets uses a certain number of user-readable strings such as
<tt>"help"</tt> or <tt>"Load file"</tt> which should be translated to the
users language if it is different from English. wxWidgets has built in support
for internationalization (i18n from now on) which allows for this to happen
automatically if the translations to the current language are available.

<p>
You may find here the list of all existing translations with the addresses of
the official translators whom you should contact if you would like to submit
any corrections to the translations for your language (click on language code
to display list of translators). Also, please
<a href="#howtohelp">see below</a> if you would like to translate wxWidgets to
your language if it is not mentioned here (or to help with one which already
is -- it is quite helpful to have several translators for one language at
least for proof reading).

<hr> 
<center>
<font size=+2><i><b><a name="available">Available translations</a></b></i></font>
</center>
<hr>

<p>
Below is the table containing the list of languages supported by wxWidgets.
The columns of this table have the obvious meaning: in each row you will see
the language and the status of the translations as of current CVS version of
wxWidgets (regenerated once a day). Click on language name to see the list
of translators for that language.

<p>

<style type="text/css">
<!--
/* ------------- Translations statistics ------------------- */

table.translations
{
    border: solid;
    border-width: 1px;
    text-align: left;
}

.incomplete
{
    background-color: #C8D4E0;
}

.untrans
{
    color: #d42323;
    text-align: right;
}
.trans
{
    color: #1B6C00;
    text-align: right;
}
.fuzzy
{
    color: #05359B;
    text-align: right;
}

.graph
{
    text-align: center;
}

.template
{
    font-style: italic;
}
-->
</style>

<center>

<?php 
$catstatus = array();
include '__catstatus.php';
?>

<p>

<table class="translations">
    <tr>
        <th class="lang">language</th>
        <th class="trans">translated</th>
        <th class="fuzzy">fuzzy</th>
        <th class="untrans">untranslated</th>
        <th class="graph">graph</th>
        <th class="download">download</th>
    </tr>
    <?php
        function get_langname($langcode)
        {
            global $langnames;
            if (strlen($langcode) > 2 && $langcode[2] == '_')
                $key=$langcode[0].$langcode[1];
            else
                $key=$langcode;
            return $langnames[$key];
        }

        function cmp_catstatus($a, $b)
        {
            $la = get_langname($a);
            $lb = get_langname($b);

            if ($la == $lb) {
                return 0;
            }
            return ($la < $lb) ? -1 : 1;
        }

        uksort($catstatus, "cmp_catstatus");
        
        while (list($lang, $value) = each ($catstatus))
        {
            $cnt_total = $value[0] + $value[1] + $value[2];
            $cnt_trans = 100 * $value[0] / $cnt_total;
            $cnt_fuzzy = 100 * $value[1] / $cnt_total;
            $cnt_untrans = 100 * $value[2] / $cnt_total;
            $w_trans = (int)($graph_width * $value[0] / $cnt_total);
            $w_fuzzy = (int)($graph_width * ($value[0] + $value[1]) / $cnt_total) - $w_trans;
            $w_untrans = (int)($graph_width * ($value[0] + $value[1] + $value[2]) / $cnt_total) - $w_trans - $w_fuzzy;
            if ($value[1] + $value[2] > 0)
                echo "<tr class=\"incomplete\">";
            else
                echo "<tr class=\"complete\">";
            $key=$lang[0].$lang[1];
            echo "<td class=\"lang\"><a href=\"i18n.php?info=$lang\">$langnames[$key] ($lang)</a></td>";
            printf("<td class=\"trans\">%0.1f %%</td>", $cnt_trans);
            printf("<td class=\"fuzzy\">%0.1f %%</td>", $cnt_fuzzy);
            printf("<td class=\"untrans\">%0.1f %%</td>", $cnt_untrans);
            echo "<td class=\"graph\">";
            if ($cnt_trans != 0) {
                echo "<img src=\"$img_translated\" width=\"$w_trans\" height=\"16\"/>";
            }
            if ($cnt_fuzzy != 0) {
                echo "<img src=\"$img_fuzzy\" width=\"$w_fuzzy\" height=\"16\"/>";
            }
            if ($cnt_untrans != 0) {
                echo "<img src=\"$img_untranslated\" width=\"$w_untrans\" height=\"16\"/>";
            }
            echo "</td>";
            echo "<td class=\"download\"><a href=\"$cvs_url$lang.po?rev=$cvs_branch&content-type=text/plain\">$lang.po</a></td>";
            echo "</tr>\n";
        }

        echo "<tr class=\"template\">";
        echo "<td>Template file</td><td></td><td></td><td></td><td></td>";
        echo "<td class=\"download\"><a href=\"$cvs_url$potfile?rev=$cvs_branch&content-type=text/plain\">$potfile</a></td>";
        echo "</tr>\n"
     ?>
</table>

</p>

</p>


</center>

<br>

<hr> 
<center>
<font size=+2><i><b><a name="howtohelp">How to help</a></b></i></font>
</center>
<hr>

<p>
wxWidgets uses the standard GNU gettext tools for i18n so if you are already
familiar with them you shouldn&#39;t have any problems with working on wxWidgets
translations. Here are the the steps you should follow:
<ol>
    <li>Get the latest version of the file <tt>locale/wxstd.po</tt> from the
        wxWidgets source tree: if you&#39;re using <a href="cvs.htm">cvs</a>
        or the <a href="http://wxwindows.sf.net/snapshots/">daily snapshots</a>,
        you should already have it. Otherwise you can always
        retrieve it directly from the cvs repository via the Web interface
        <a href="http://cvs.wxwindows.org/viewcvs.cgi/wxWidgets/locale/wxstd.po">here</a>.

    <li>Rename it to <tt>ll_CC.po</tt> where <tt>"ll"</tt> is the 2 letter
        <a href="http://lcweb.loc.gov/standards/iso639-2/englangn.html">ISO 639-1 language code</a>
        for your language and <tt>"CC"</tt> is the 2 letter
        <a href="http://www.iso.ch/iso/en/prods-services/iso3166ma/02iso-3166-code-lists/list-en1.html">
        ISO 3166 country code</a>. If the country is the default one for this
        language (e.g. Italy is default country for Italian), then the country part and underscore
        preceding it should be omitted -- this is, in fact, the most common case.

    <li>Translate the strings in this file using either your favourite text
        editor or a specialized tool such as Vaclav Slavik&#39;s excellent
        <a href="http://poedit.sourceforge.net/" target=_top>poEdit</a>
        utility.

    <li>Verify that your translations can at least be compiled (even if they
        are yet incomplete) by running <tt>msgfmt -v ll_CC.po</tt> command:
        please note that you <i>must</i> use the <tt>-v</tt> option. In
        particular, please fill the header fields because msgfmt doesn&#39;t
        accept the default values for them.

    <li>Send the finished translation to
        <a href="mailto:vadim@wxwindows.org">Vadim Zeitlin</a> and it will be
        added to the next wxWidgets release or snapshot.
</ol>

<p>
In addition, please consider subscribing to the very low volume
<a href="http://www.wxwidgets.org/maillst2.htm#translators">
wxWidgets translators</a> mailing list on which the news especially important
for the translators are announced.

<p>
Thank you in advance for your help!

<hr>
Please contact <a href="mailto:vadim@wxwindows.org">me</A> with
any comments/suggestions.


<?php
}
// ----------------------------------------------------------------------
//             Display information about single translation:
// ----------------------------------------------------------------------
else {
   $langshort=$language[0].$language[1];
?>

<table width=100% border=0 cellpadding=3 cellspacing=0>
<tr>
<td bgcolor="#004080" align=left height=24 background="images/bluetitlegradient.gif">
<font size=+1 face="Arial, Lucida Sans, Helvetica" color="#FFFFFF">
<b>Language: <?php echo "$langnames[$langshort] ($language)"; ?></b>
</font>
</td>
</tr>
</table>
<p>
Translators:<p>
<?php echo $translators[$language]; ?>
<p>
<p>
(Note that email addresses contain double @ as anti-spam measure, you'll have
to remove one if you want to send email to the translators.)
</p>

<?php
}
?>


</body>
</html>


